﻿@{
    ViewData["Title"] = "Client Acquisition Pipeline";
}
<link href="~/assets/css/kanban.bundle.css" rel="stylesheet" type="text/css" />
<link href="~/css/custom-kanban.css" rel="stylesheet" type="text/css" asp-append-version="true" />
<div class="container">
    <div class="card">
        <div class="card-header flex-wrap border-0 pt-6 pb-0">
            <div class="card-title mb-0" id="main-card">
                <div class="d-flex justify-content-between">
                    <div class="flex-grow-1">
                        <h3 class="card-label text-primary">
                            Client Acquisition Pipeline
                        </h3>
                    </div>
                    <div style="width:500px">
                        <div class="input-daterange input-group" id="daterangepicker">
                            <label class="mr-3 mt-3 font-size-h6">Filter by Date: </label>
                            <input type="text" class="form-control datemask" name="start" id="StartDate">
                            <div class="input-group-append">
                                <span class="input-group-text">
                                    To
                                </span>
                            </div>
                            <input type="text" class="form-control datemask" name="end" id="EndDate" disabled>
                            <button class="btn btn-sm btn-primary ml-3" onclick="BindKanbanBoard(true);" id="btn-search" disabled><i class="fa fa-search"></i></button>
                            <button class="btn btn-sm btn-light-dark ml-3" onclick="clearDates();" id="btn-clear-filter">Clear</button>
                        </div>
                    </div>
                </div>
                <div id="selected-lead-container" class="text-right font-size-h6 mr-5 mt-3 d-none">Total <span id="selected-lead" class="font-weight-bolder text-primary"></span> Lead(s) Selected</div>
            </div>
        </div>
        <div class="card-body pt-0">
            <div id="main-container">
                <div id="marketing_kanban" class="min-h-100px">
                    <div class="mb-3" id="board-info-container">
                        <div class="board-title-info">
                            <span class="label label-outline-primary label-inline mr-2 mb-2 p-4" data-toggle="tooltip" data-placement="top" data-original-title="Establish Rapport" data-boundary="window" role="button">E</span><br />
                            <div class="d-flex">
                                <div class="w-50">
                                    <span class="label label-outline-dark label-inline mr-2 p-4 invisible" data-id="6">%</span>
                                </div>
                                <div class="w-50">
                                    <span class="label label-outline-dark label-inline mr-2 p-4" data-id="7">%</span>
                                </div>
                            </div>
                        </div>
                        <div class="board-title-info">
                            <span class="label label-outline-primary label-inline mr-2 mb-2 p-4" data-toggle="tooltip" data-placement="top" data-original-title="Gather Information" data-boundary="window" role="button">G</span><br />
                            <span class="label label-outline-dark label-inline mr-2 p-4" data-id="1">%</span>
                        </div>
                        <div class="board-title-info">
                            <span class="label label-outline-primary label-inline mr-2 mb-2 p-4" data-toggle="tooltip" data-placement="top" data-original-title="Analyze Information" data-boundary="window" role="button">A</span>
                            <span class="label label-outline-primary label-inline mr-2 mb-2 p-4" data-toggle="tooltip" data-placement="top" data-original-title="Design Plan" data-boundary="window" role="button">D</span><br />
                            <span class="label label-outline-dark label-inline mr-2 p-4" data-id="2">%</span>
                        </div>
                        <div class="board-title-info">
                            <span class="label label-outline-primary label-inline mr-2 mb-2 p-4" data-toggle="tooltip" data-placement="top" data-original-title="Implement Plan" data-boundary="window" role="button">I</span><br />
                            <span class="label label-outline-dark label-inline mr-2 p-4" data-id="3">%</span>
                        </div>
                        <div class="board-title-info">
                            <span class="label label-outline-primary label-inline mr-2 mb-2 p-4" data-toggle="tooltip" data-placement="top" data-original-title="Monitor Plan" data-boundary="window" role="button">M</span><br />
                            <span class="label label-outline-dark label-inline mr-2 p-4 invisible" data-id="4"></span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="modal" id="ActivityModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<script src="https://cdn.jsdelivr.net/npm/jkanban@1.3.1/dist/jkanban.js"></script>
<script src="~/lib/lodash.min.js"></script>
@section scripts{
    <script>
        var fromFilter;
        var InsertItemIndex = 0;
        var autoScroll = function () {
            var element = $(".gu-mirror").offset();
            if (element) {
                let left = element.left;
                if (left > 1340)
                    document.querySelector("#main-container").scrollLeft += 5;
                else if (left < 300)
                    document.querySelector("#main-container").scrollLeft -= 5;

                let top = element.top;
                if ((top > 430 && top < 460) || top > 740)
                    document.querySelector(".is-moving").closest(".kanban-drag").scrollTop += 5;
                else if (top < 250 || (top > 460 && top < 540))
                    document.querySelector(".is-moving").closest(".kanban-drag").scrollTop -= 5;
            }
        }
        var dataCountArray = [];
        var updateBoardStatistics = function () {
            dataCountArray = [];
            $(".kanban-board").each(function () {
                var columnOrder = $(this).attr("data-order");
                var columnId = $(this).attr("data-id");
                var columnCount = $(`[data-order='${columnOrder}'] .kanban-item`).length;
                var falloutColumnCount = 0;
                if (columnOrder != 0 && columnOrder <= 7) {
                    if (columnId > 0 && columnId <= 3) {
                        var falloutColumnOrder = Number(columnOrder) + 7;
                        falloutColumnCount = $(`[data-order='${falloutColumnOrder}'] .kanban-item`).length;
                        columnCount = columnCount + falloutColumnCount;
                    }
                    dataCountArray.push({ id: columnId, order: columnOrder, count: columnCount });
                }
                $(this).find(".kanban-board-header .card-count").remove();
                $(this).find(".kanban-board-header").append(`<div class="card-count d-flex justify-content-between">
                                                                                                                                                                                                                                                                                                                                                                                        <div class="card-total-count">${columnCount - falloutColumnCount} Cards</div>
                                                                                                                                                                                                                                                                                                                                                                                        <div class="selected-lead-count"></div>
                                                                                                                                                                                                                                                                                                                                                                                     </div>`);

            });
            $.each(dataCountArray, function (i, item) {
                var filterdData = dataCountArray.filter(m => m.order >= item.order);
                item.aggregateCount = _.sumBy(filterdData, 'count');
                var percentage = (item.aggregateCount - item.count) / item.aggregateCount * 100;
                item.percentage = percentage == "Infinity" ? 100 : percentage ? Math.round(percentage) : 0;
                $(`.board-title-info [data-id='${item.id}']`).text(`${Math.round(item.percentage)}%`);
            });
        }
        var SaveEventComplete = function (response) {
            $("#ActivityModal").modal('hide');
            var responseObj = JSON.parse(response.responseText);
            var frm_id = $(this).attr('id');
            if (responseObj) {
                if (responseObj.success) {
                    kanban.removeElement(responseObj.data.guid);
                    kanban.addElement(responseObj.data.targetBoardId, { title: responseObj.data.title }, InsertItemIndex);
                    updateKanbanItemGuid(responseObj.data.targetBoardId);
                    updateBoardStatistics();
                }
                else {
                    var start = $("#startDateTime").val();
                    var end = $("#endDateTime").val();
                    var guid = $("#Guid").val();
                    showOverLappedActivity(start, end, guid, frm_id, responseObj.message);
                }
            }
        }
        var updateKanbanItemGuid = function (boradId) {
            $(`.kanban-board[data-id='${boradId}'] .kanban-item`).each(function () {
                var hasGuid = $(this).attr("data-eid");
                var guid = $(this).find(".guid").val();
                if (!hasGuid || hasGuid != guid)
                    $(this).attr("data-eid", guid);
            });
        }
        var kanban;
        toastr.options = toastrOptions;
        localStorage.setItem("adviserLastPageHref", 'user/client-acquisition-pipeline');
        var BindKanbanBoard = function (filter) {
            fromFilter = filter;
            $("#selected-lead-container").addClass("d-none");
            $("#btn-clear-filter").prop("disabled", true);
            $("#btn-search").prop("disabled", true);
            $("#main-card").removeClass("mb-0");
            KTApp.block(`#marketing_kanban`, {
                state: 'primary',
                message: 'Please wait...'
            });
            var startDate = $("#StartDate").val();
            var endDate = $("#EndDate").val();
            var url = !filter ? '/adviser/dashboard/GetBoardData' : `/adviser/dashboard/GetFilterBoardData?startDate=${startDate}&endDate=${endDate}`;
            $.get(url, function (response) {
                $("#marketing_kanban .kanban-container").remove();
                kanban = new jKanban({
                    element: '#marketing_kanban',
                    gutter: '0',
                    widthBoard: '180px',
                    dragBoards: false,
                    boards: response,
                    dropEl: function (el, target, source, sibling) {
                        $('[data-toggle=popover]').popover('hide');
                        var sourceBoardId = source.parentElement.getAttribute('data-id');
                        var targetBoardId = target.parentElement.getAttribute('data-id');
                        if (sourceBoardId != targetBoardId) {
                            var guid = $(el).find(".guid").val();
                            var falloutStatus = targetBoardId >= 8 && targetBoardId <= 10 ? Number(targetBoardId) - 7 : 0;
                            var exclude = {
                                1: [5, 6, 7, 9, 10],
                                2: [1, 5, 6, 7, 8, 10],
                                3: [1, 2, 5, 6, 7, 8, 9],
                                4: [1, 2, 3, 5, 6, 7, 8, 9, 10],
                                5: [1, 2, 3, 4, 6, 7, 8, 9, 10],
                                6: [1, 2, 3, 4, 5, 7, 8, 9, 10],
                                7: [5, 6, 7, 8, 9, 10],
                                8: [6, 7, 3, 4, 5, 6, 7, 9, 10],
                                9: [1, 4, 5, 6, 7, 8, 9, 10],
                                10: [1, 2, 5, 6, 7, 8, 9]
                            }
                            if (filter || exclude[`${sourceBoardId}`].includes(Number(targetBoardId))) {
                                kanban.drake.cancel(true);
                                toastr.error("This functionality is not allowed.");
                            }
                            else if (targetBoardId >= 1 && targetBoardId <= 3) {
                                kanban.drake.cancel(true);
                                KTApp.blockPage({
                                    overlayColor: '#000000',
                                    state: 'primary',
                                    message: 'Please wait...'
                                });
                                var guid = $(el).find(".guid").val();
                                var eventType = ActivityTypes.ProspectAppointment.Value;
                                $("#ActivityModal").html("");
                                loadPartialView(`adviser/dashboard/addprospectappointment?guid=${guid}&activityType=${eventType}`, "ActivityModal", null, function () {
                                    setTimeout(function () {
                                        $("#name-container input").prop("disabled", true);
                                        $("#Status").val("").trigger("change");
                                        $("#Stage").val(targetBoardId).trigger("change");
                                        $("#appoinment-container input[type='text']").val("");
                                        $("#FallOut").val("false");
                                        var kanbanGuid = $(sibling).attr("data-eid");
                                        InsertItemIndex = kanbanGuid ? $(`.kanban-item[data-eid='${kanbanGuid}']`).index() : $(target).find(".kanban-item").length;
                                        $('#StartTimepicker,#EndTimepicker').datetimepicker({
                                            stepping: 15,
                                            ignoreReadonly: true,
                                            format: 'LT'
                                        });
                                    }, 0);
                                });
                                setTimeout(function () {
                                    KTApp.unblockPage();
                                }, 1000);
                                $("#ActivityModal").modal({
                                    backdrop: 'static'
                                });
                            }
                            else {
                                $.post('/adviser/dashboard/UpdateKanbanItemStatus', {
                                    guid: guid,
                                    status: targetBoardId,
                                    falloutStatus: falloutStatus
                                }, function (res) {
                                    if (res.success) {
                                        $(el).find(".initial").removeClass(`symbol-light-${res.data.sourceClass}`).addClass(`symbol-light-${res.data.targetClass}`);
                                        $(el).find(".status").removeClass(`label-outline-${res.data.sourceClass}`).addClass(`label-outline-${res.data.targetClass}`);
                                        $(el).find(".status").text(res.data.statusName);
                                        $(el).find(".guid").val(res.data.guid);
                                        updateKanbanItemGuid(targetBoardId);
                                        updateBoardStatistics();
                                    }
                                })
                            }
                        }
                    },
                });
                $(".kanban-board[data-id='6'] .status").removeClass("status").addClass("send-invite");
                updateBoardStatistics();
                if (fromFilter) {
                    $(".kanban-board").addClass("kanban-board-disabled");
                    $("#btn-clear-filter").prop("disabled", false);
                    $(".send-invite").removeClass("send-invite");
                    kanban.drake.destroy();
                }
                KTApp.unblock(`#marketing_kanban`);
            });
        }
        var getPopoverContent = function (guid) {
            $.get(`adviser/dashboard/GetProspectAppointmentDetail?guid=${guid}&fromFilter=${fromFilter}`, function (response) {
                $('#popover').html(response);
                $(".event-popover .popover-body .add-edit-event").attr("data-guid", guid);
                $(".event-popover .popover-body .delete-event").attr("data-guid", guid)
            });
            return '<div id="popover">Loading <span class="spinner spinner-sm spinner-primary ml-2"></span></div>';
        }
        $(document).on("click", ".kanban-item", function (el) {
            if (!fromFilter) {
                var element = $(el.currentTarget);
                var guid = element.find(".guid").val();
                var content = getPopoverContent(guid);
                element.attr("role", "button").attr('data-toggle', 'popover');
                element.popover({
                    trigger: 'click',
                    html: true,
                    content: content,
                    placement: 'auto',
                    boundary: 'window'
                });
                element.popover().on("show.bs.popover", function () {
                    setTimeout(function () {
                        $(".popover").addClass("event-popover");
                    }, 0);
                });
                element.popover('show');
            }
        });
        $(document).on("click", ".send-invite", function (e) {
            var guid = $(this).attr("data-guid");
            e.stopPropagation();
            var swalOptionsInvite = confimationSwalOptions;
            swalOptionsInvite.title = "Confirmation";
            swalOptionsInvite.text = "";
            swalOptionsInvite.html = "You have selected to send an email to this lead. <br/> Do you wish to continue and invite your lead to LifeArcPlan or Cancel?";
            swalOptionsInvite.confirmButtonText = "Send Invite";
            Swal.fire(swalOptionsInvite)
                .then(function (result) {
                    if (result.value) {
                        var loading = $(".send-invite.spinner").length;
                        if (!loading) {
                            KTUtil.btnWait(e.target, "spinner spinner-xs spinner-right spinner-white pr-10", "Sending");
                            $.post('adviser/home/SendInviteToLead', {
                                guid: guid
                            }, function (response) {
                                if (response) {
                                    if (response.success) {
                                        KTUtil.btnRelease(e.target);
                                        kanban.moveElement("7", guid, {
                                            title: response.data.title
                                        });
                                        updateKanbanItemGuid("7");
                                        updateBoardStatistics();
                                        var swalOptionsSuccess = successSwalOptions;
                                        swalOptionsSuccess.title = response.message;
                                        Swal.fire(swalOptionsSuccess);
                                    } else {
                                        toastr.error(response.message);
                                    }
                                }
                            })
                        } else
                            toastr.warning("Please wait untill the invite is sent");
                    }
                });
        });
        setInterval(function () {
            autoScroll();
        }, 15);
        BindKanbanBoard();
        $('#daterangepicker').datepicker({
            orientation: "bottom left",
            autoclose: true,
            todayHighlight: true,
            format: 'mm/dd/yyyy',
            startDate: '-100y',
            endDate: '+100y'
        })
            .on('changeDate', function (e) {
                var startDate = $("#StartDate").val();
                var endDate = $("#EndDate").val();
                $("#EndDate").prop("disabled", false);
                if (new Date(startDate) <= new Date(endDate)) {
                    $("#btn-search").prop("disabled", false);
                }
            })
        var clearDates = function () {
            $('#daterangepicker').datepicker('clearDates');
            $("#EndDate").prop("disabled", true);
            BindKanbanBoard();
        }
        $(document).on('click', '.delete-event', function (e) {
            var cur = this;
            if ($(cur).hasClass("has-leads") || $(cur).hasClass("has-client-leads"))
                return false;
            var swalOptionsConfirmation = confimationSwalOptions2;
            swalOptionsConfirmation.text = "Deactivating the lead(s) will permanently remove them from the system";
            Swal.fire(swalOptionsConfirmation)
                .then(function (result) {
                    if (result.value) {
                        var guid = $(cur).attr("data-guid");
                        var eventType = ActivityTypes.ProspectAppointment.Value;
                        deleteRecord(`adviser/dashboard/DeleteEvent?guid=${guid}&activityType=${eventType}`, function (response) {
                            if (response.success) {
                                KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
                                kanban.removeElement(guid);
                                setTimeout(function () { KTApp.unblockPage(); }, 1000);
                            }
                            else
                                Swal.fire("Cancelled", response.message, "error");
                        });
                    }
                });
        });
    </script>
}